SystemOrganization addCategory: #'Magritte-Core-Descriptions'!
SystemOrganization addCategory: #'Magritte-Core-Comparators'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Utilities'!
SystemOrganization addCategory: #'Magritte-Core-Tests'!

ProtoObject subclass: #MAProxyObject
	instanceVariableNames: 'realSubject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAProxyObject subclass: #MADynamicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MADynamicObject methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:44'!
realSubject
	^super realSubject value.! !

!MAProxyObject class methodsFor: 'instance creation' stamp: 'lr 1/1/2005 15:58'!
on: anObject
	^self basicNew realSubject: anObject.! !

!MAProxyObject methodsFor: 'private' stamp: 'lr 2/28/2005 16:05'!
doesNotUnderstand: aMessage
	^self realSubject
		perform: aMessage selector
		withArguments: aMessage arguments.! !

!MAProxyObject methodsFor: 'testing' stamp: 'lr 2/28/2005 16:05'!
isNil
	^self realSubject isNil.! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printOn: aStream
	aStream nextPut: $[; print: self realSubject; nextPut: $].! !

!MAProxyObject methodsFor: 'printing' stamp: 'lr 2/28/2005 16:05'!
printString
	^String streamContents: [ :stream | self printOn: stream ].! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject
	^realSubject! !

!MAProxyObject methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:05'!
realSubject: anObject
	realSubject := anObject! !

!UndefinedObject methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'n/a'! !

Error subclass: #MAError
	instanceVariableNames: 'resumeable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAError class methodsFor: 'instance creation' stamp: 'lr 3/14/2005 17:00'!
description: aDescription message: aString
	^self description: aDescription message: aString resumeable: false.! !

!MAError class methodsFor: 'instance creation' stamp: 'lr 3/14/2005 16:52'!
description: aDescription message: aString resumeable: aBoolean
	^self new
		tag: aDescription;
		resumeable: aBoolean;
		signal: aString.! !

!MAError methodsFor: 'testing' stamp: 'lr 3/14/2005 16:51'!
isResumeable
	^self resumeable.! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/14/2005 16:51'!
resumeable
	^resumeable! !

!MAError methodsFor: 'accessing' stamp: 'lr 3/14/2005 16:51'!
resumeable: aBoolean
	resumeable := aBoolean! !

MAError subclass: #MAReadonlyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAError subclass: #MARequiredError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAError subclass: #MAValidationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

MABuilder class
	instanceVariableNames: 'default'!

!MABuilder class methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:55'!
default
	default isNil
		ifTrue: [ default := self new ].
	^default.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^anObject defaultContainer in: [ :container |
		anObject class allSelectors do: [ :each |
			(self isDescriptionSelector: each)
				ifTrue: [ container append: (anObject perform: each) ] ].
		container ].! !

!MABuilder methodsFor: 'testing' stamp: 'lr 3/9/2005 22:42'!
isDescriptionSelector: aSelector
	^aSelector isUnary 
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 11:22'!
buildFor: anObject
	^self cache
		at: anObject
		ifAbsentPut: [ super buildFor: anObject ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 10:56'!
flush
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:56'!
initialize
	super initialize.
	self flush.! !

Object subclass: #MAComparator
	instanceVariableNames: ''
	classVariableNames: 'LessThan Match NotEqualTo GreaterThanOrEqualTo EndsWith BeginsWith GreaterThan LessThanOrEqualTo EqualTo'
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:12'!
beginsWith
	^BeginsWith! !

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:12'!
endsWith
	^EndsWith! !

!MAComparator class methodsFor: 'accessing-equality' stamp: 'lr 3/19/2005 21:12'!
equalTo 
	^EqualTo! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:45'!
equalityComparators
	^Array with: self equalTo with: self notEqualTo.! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
greaterThan	
	^GreaterThan! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:18'!
greaterThanOrEqualTo
	^GreaterThanOrEqualTo! !

!MAComparator class methodsFor: 'class initialization' stamp: 'lr 3/19/2005 22:32'!
initialize

	" equality comparators "
	EqualTo := MAGenericComparator label: 'equal to' selector: #=.
	NotEqualTo := MAGenericComparator label: 'not equal to' selector: #~=.
	
	" magnitude comparators "
	LessThan := MAGenericComparator label: 'less than' selector: #<.
	LessThanOrEqualTo := MAGenericComparator label: 'less than or equal to' selector: #<=.
	GreaterThan := MAGenericComparator label: 'greater than' selector: #>.
	GreaterThanOrEqualTo := MAGenericComparator label: 'greater than' selector: #>=.
	
	" string comparators "
	BeginsWith := MAGenericComparator label: 'begins with' selector: #beginsWith:.
	EndsWith := MAGenericComparator label: 'ends with' selector: #endsWith:.
	Match := MAMatchComparator new.! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
lessThan
	^LessThan! !

!MAComparator class methodsFor: 'accessing-magnitude' stamp: 'lr 3/19/2005 21:13'!
lessThanOrEqualTo
	^LessThanOrEqualTo! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:46'!
magnitudeComparators
	^Array with: self lessThan with: self lessThanOrEqualTo with: self greaterThan with: self greaterThanOrEqualTo.! !

!MAComparator class methodsFor: 'accessing-string' stamp: 'lr 3/19/2005 21:53'!
match
	^Match! !

!MAComparator class methodsFor: 'accessing-equality' stamp: 'lr 3/19/2005 21:13'!
notEqualTo
	^NotEqualTo! !

!MAComparator class methodsFor: 'accessing' stamp: 'lr 3/19/2005 21:53'!
stringComparators
	^Array with: self beginsWith with: self endsWith with: self match.! !

!MAComparator methodsFor: 'converting' stamp: 'lr 3/19/2005 21:27'!
asSelector
	self subclassResponsability.! !

!MAComparator methodsFor: 'private' stamp: 'lr 3/17/2005 15:30'!
compare: aLeftObject to: aRightObject
	self subclassResponsibility.! !

!MAComparator methodsFor: 'comparing' stamp: 'lr 3/17/2005 15:38'!
compare: aLeftObject with: aRightObject
	^[ self compare: aLeftObject to: aRightObject ]
		ifError: [ false ].! !

!MAComparator methodsFor: 'comparing' stamp: 'lr 3/20/2005 01:13'!
compare: aLeftObject with: aRightObject description: aDescription
	^(aDescription comparators includes: self) and: [
		self
			compare: (aDescription read: aRightObject)
			with: (aDescription parseString: aLeftObject) ].! !

MAComparator subclass: #MAGenericComparator
	instanceVariableNames: 'label selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAGenericComparator class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 21:43'!
label: aString selector: aSelector
	^self new
		setLabel: aString;
		setSelector: aSelector;
		yourself.! !

!MAGenericComparator methodsFor: 'converting' stamp: 'lr 3/19/2005 21:22'!
asLabel
	^label! !

!MAGenericComparator methodsFor: 'converting' stamp: 'lr 3/19/2005 21:41'!
asSelector
	^selector! !

!MAGenericComparator methodsFor: 'private' stamp: 'lr 3/19/2005 21:42'!
compare: aLeftObject to: aRightObject
	^aLeftObject perform: selector with: aRightObject.! !

!MAGenericComparator methodsFor: 'initialization' stamp: 'lr 3/19/2005 21:22'!
setLabel: aString
	label := aString! !

!MAGenericComparator methodsFor: 'initialization' stamp: 'lr 3/19/2005 21:41'!
setSelector: aSymbol
	selector := aSymbol! !

MAComparator subclass: #MAMatchComparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Comparators'!

!MAMatchComparator methodsFor: 'converting' stamp: 'lr 3/19/2005 22:27'!
asLabel
	^ 'match'! !

!MAMatchComparator methodsFor: 'converting' stamp: 'lr 3/19/2005 22:26'!
asSelector
	^ #match:! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/20/2005 01:13'!
compare: aLeftObject to: aRightObject
	^(self patternFor: aRightObject) match: aLeftObject.! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/19/2005 22:36'!
includesJoker: aString
	^aString includesAnyOf: #( $* $# ).! !

!MAMatchComparator methodsFor: 'private' stamp: 'lr 3/19/2005 22:31'!
patternFor: aString
	^(self includesJoker: aString)
		ifTrue: [ aString ]
		ifFalse: [ '*' , aString , '*' ].! !

Object subclass: #MADescription
	instanceVariableNames: 'key label properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MADescription subclass: #MAComposedDescription
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAComposedDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MAComposedDescription methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
add: aDescription
	self remove: aDescription.
	self children add: aDescription.! !

!MAComposedDescription methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAComposedDescription methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
append: anObject
	(anObject isKindOf: MADescription)
		ifTrue: [ self add: anObject ]
		ifFalse: [ 
			anObject isCollection
				ifTrue: [ self addAll: anObject ] ].! !

!MAComposedDescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol
	^children detect: [ :each | aSymbol = each key ].! !

!MAComposedDescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
at: aSymbol ifAbsent: aBlock
	^children detect: [ :each | aSymbol = each key ] ifNone: aBlock.! !

!MAComposedDescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:51'!
children
	^children! !

!MAComposedDescription methodsFor: 'accessing-configuration' stamp: 'lr 3/11/2005 11:30'!
defaultChildCollection
	^OrderedCollection new.! !

!MAComposedDescription methodsFor: 'enumeration' stamp: 'lr 3/10/2005 10:52'!
do: aBlock
	self children do: aBlock.! !

!MAComposedDescription methodsFor: 'testing' stamp: 'lr 3/17/2005 09:50'!
hasChildren
	^self children notEmpty.! !

!MAComposedDescription methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 10:53'!
initialize
	super initialize.
	children := self defaultChildCollection.! !

!MAComposedDescription methodsFor: 'copying' stamp: 'lr 3/10/2005 10:53'!
postCopy
	super postCopy.
	children := self defaultChildCollection 
		addAll: (self children collect: [ :each | each copy ]);
		yourself.! !

!MAComposedDescription methodsFor: 'enumeration' stamp: 'lr 3/11/2005 09:48'!
reject: aBlock
	^self select: [ :each | (aBlock value: each) not ].! !

!MAComposedDescription methodsFor: 'modification' stamp: 'lr 3/9/2005 22:52'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MAComposedDescription methodsFor: 'modification' stamp: 'lr 3/11/2005 09:40'!
removeAll
	children := self defaultChildCollection.! !

!MAComposedDescription methodsFor: 'enumeration' stamp: 'lr 3/11/2005 09:40'!
select: aBlock
	^self copy
		removeAll;
		addAll: (self children 
			select: aBlock);
		yourself.! !

MAComposedDescription subclass: #MAPriorityContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAPriorityContainer methodsFor: 'accessing-configuration' stamp: 'lr 3/11/2005 11:30'!
defaultChildCollection
	^SortedCollection sortBlock: [ :a :b | a priority <= b priority ].! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:17'!
defaultKey
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/19/2005 12:30'!
defaultPersistent
	^true! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:27'!
defaultPriority
	^0! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:23'!
defaultReadonly
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/11/2005 20:39'!
defaultRequired
	^false! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	^super defaultTitle allButFirst: 2.! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 10:28'!
defaultVisible
	^true! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:09'!
descriptionKey
	^MASymbolDescription key: #key label: 'Key' priority: 100 default: self defaultKey.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:07'!
descriptionLabel
	^MAStringDescription key: #label label: 'Label' priority: 110 default: self defaultLabel.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/22/2005 07:43'!
descriptionPersistent
	^MABooleanDescription key: #persistent label: 'Persistent' priority: 230 default: self defaultPersistent.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:12'!
descriptionPriority
	^MANumberDescription key: #priority label: 'Priority' priority: 120 default: self defaultPriority.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:11'!
descriptionReadonly
	^MABooleanDescription key: #readonly label: 'Readonly' priority: 200 default: self defaultReadonly.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:11'!
descriptionRequired
	^MABooleanDescription key: #required label: 'Required' priority: 220 default: self defaultRequired.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:11'!
descriptionVisible
	^MABooleanDescription key: #visible label: 'Visible' priority: 210 default: self defaultVisible.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^true! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey
	^self key: aKey label: aKey asString.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString
	^self key: aKey label: aString priority: self defaultPriority.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:10'!
key: aKey label: aString priority: aNumber
	^self new
		key: aKey;
		label: aString;
		priority: aNumber;
		readonly: self defaultReadonly;
		visible: self defaultVisible;
		yourself.! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 10:31'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'converting' stamp: 'lr 3/16/2005 15:25'!
asLabel
	^self label.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
beEphemeral
	self persistent: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beHidden
	self visible: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:31'!
beOptional
	self required: false.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/14/2005 18:12'!
bePersistent
	self persistent: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beReadonly
	self readonly: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/11/2005 20:25'!
beRequired
	self required: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beVisible
	self visible: true.! !

!MADescription methodsFor: 'actions' stamp: 'lr 3/10/2005 10:14'!
beWriteable
	self readonly: false.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/17/2005 09:50'!
hasChildren
	^false! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/14/2005 18:11'!
isPersistent
	^self persistent.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isReadonly
	^self readonly.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/11/2005 20:31'!
isRequired
	^self required.! !

!MADescription methodsFor: 'testing' stamp: 'lr 3/10/2005 10:14'!
isVisible
	^self visible.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key
	^key! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
key: anObject
	key := anObject! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label
	^label! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/10/2005 10:04'!
label: aString
	label := aString! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/19/2005 12:30'!
persistent	
	^self 
		propertyAt: #persistent 
		ifAbsent: [ self class defaultPersistent ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/14/2005 18:11'!
persistent: aBoolean
	self propertyAt: #persistent put: aBoolean.! !

!MADescription methodsFor: 'copying' stamp: 'lr 3/10/2005 10:54'!
postCopy
	super postCopy.
	properties := properties copy.! !

!MADescription methodsFor: 'printing' stamp: 'lr 3/17/2005 15:15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' key: '; print: self key.
	aStream nextPutAll: ' label: '; print: self label.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/17/2005 15:17'!
priority
	^self 
		propertyAt: #priority 
		ifAbsent: [ self class defaultPriority ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/17/2005 15:17'!
priority: aNumber
	self propertyAt: #priority put: aNumber.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/17/2005 15:19'!
properties
	properties isNil
		ifTrue: [ properties := Dictionary new ].
	^properties.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyAt: aKey
	^self properties at: aKey.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:12'!
propertyAt: aKey put: aValue
	self properties at: aKey put: aValue.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/10/2005 10:13'!
propertyIncludes: aKey
	^self properties includesKey: aKey.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
readonly	
	^self 
		propertyAt: #readonly 
		ifAbsent: [ self class defaultReadonly ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
readonly: aBoolean	
	self propertyAt: #readonly put: aBoolean.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/11/2005 20:24'!
required	
	^self 
		propertyAt: #required 
		ifAbsent: [ self class defaultRequired ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/11/2005 20:24'!
required: aBoolean	
	self propertyAt: #required put: aBoolean.! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
visible	
	^self 
		propertyAt: #visible 
		ifAbsent: [ self class defaultVisible ].! !

!MADescription methodsFor: 'accessing-settings' stamp: 'lr 3/10/2005 10:11'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MADescription subclass: #MAElementDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MAElementDescription subclass: #MABinaryDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MABinaryDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:42'!
defaultTitle
	^'Upload Field'! !

!MABinaryDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 21:39'!
descriptionDefault
	^nil! !

!MABinaryDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABinaryDescription methodsFor: 'converting' stamp: 'lr 3/15/2005 21:41'!
parseString: aString
	^self parseString: aString protected: [ ByteArray withAll: aString ].! !

!MABinaryDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:55'!
species
	^ByteArray! !

MAElementDescription subclass: #MABooleanDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MABooleanDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 11:48'!
defaultDefault
	^false! !

!MABooleanDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Check-Box'! !

!MABooleanDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
falseStrings
	^ #( 'false' 'f' 'no' 'n' '0' 'off' )! !

!MABooleanDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:10'!
parseString: aString
	^self parseString: aString protected: [
		(self trueStrings includes: aString)
			ifTrue: [ ^true ].
		(self falseStrings includes: aString)
			ifTrue: [ ^false ].
		aString ].! !

!MABooleanDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:55'!
species
	^Boolean! !

!MABooleanDescription methodsFor: 'private' stamp: 'lr 3/11/2005 21:40'!
trueStrings
	^ #( 'true' 't' 'yes' 'y' '1' 'on' )! !

!MAElementDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:48'!
defaultDefault
	^nil! !

!MAElementDescription class methodsFor: 'accessing-description' stamp: 'lr 3/19/2005 10:32'!
descriptionDefault
	^self isAbstract 
		ifFalse: [ self key: #default label: 'Default' priority: 130 default: self defaultDefault ].! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber
	^(super key: aKey label: aString priority: aNumber)
		default: self defaultDefault;
		yourself.! !

!MAElementDescription class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 10:09'!
key: aKey label: aString priority: aNumber default: aValue
	^(self key: aKey label: aString priority: aNumber)
		default: aValue;
		yourself.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/15/2005 08:54'!
collectionToString: aCollection
	^String streamContents: [ :stream |
		aCollection
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream cr ] ].! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 16:16'!
comparators
	^MAComparator equalityComparators.! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/14/2005 10:40'!
default
	^self 
		propertyAt: #default 
		ifAbsent: [ self class defaultDefault ].! !

!MAElementDescription methodsFor: 'accessing-properties' stamp: 'lr 3/14/2005 10:41'!
default: anObject
	self propertyAt: #default put: anObject.! !

!MAElementDescription methodsFor: 'private-errors' stamp: 'lr 3/14/2005 11:17'!
errorReadonly
	MAReadonlyError 
		description: self 
		message: self label , ' is readonly.'.! !

!MAElementDescription methodsFor: 'private-errors' stamp: 'lr 3/14/2005 11:17'!
errorRequired
	MARequiredError 
		description: self 
		message: self label , ' is required.'.! !

!MAElementDescription methodsFor: 'private-errors' stamp: 'lr 3/14/2005 16:36'!
errorValidation
	MAValidationError 
		description: self 
		message:  self label , ' is invalid.'.! !

!MAElementDescription methodsFor: 'testing' stamp: 'lr 3/17/2005 22:54'!
includes: anObject
	"Return true or false wether anObject is a proper value of the receiver."

	^anObject isKindOf: self species.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:12'!
migrate: anObject from: aDescription
	^self parseString: (aDescription toString: anObject).! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:15'!
parseString: aString
	^self parseString: aString protected: [ aString ].! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:15'!
parseString: aString protected: aBlock
	^aString isEmptyOrNil ifFalse: [ 
		aBlock
			on: Error
			do: [ :err | err return: aString ] ].! !

!MAElementDescription methodsFor: 'accessing-model' stamp: 'lr 3/14/2005 11:46'!
read: aModel
	"Read from aModel using the receiver as description."
	
	^(aModel readUsing: self)
		ifNil: [ self default ].! !

!MAElementDescription methodsFor: 'private' stamp: 'lr 3/10/2005 15:53'!
readSelector	
	^self key asSymbol.! !

!MAElementDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:54'!
species
	^self subclassResponsibility.! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/15/2005 23:18'!
stringToCollection: aString default: aCollection
	^aString isEmptyOrNil
		ifTrue: [ aCollection ]
		ifFalse: [
			aString withBlanksCondensed 
				findTokens: Character cr ].! !

!MAElementDescription methodsFor: 'converting' stamp: 'lr 3/13/2005 20:51'!
toString: anObject
	^anObject isNil
		ifTrue: [ String new ]
		ifFalse: [ anObject asString ].! !

!MAElementDescription methodsFor: 'accessing-model' stamp: 'lr 3/14/2005 11:13'!
validate: anObject
	"Check if anObject can be written to the model described by the receiver. In case of problems an exception is raised."

	(self isRequired and: [ anObject isNil ])
		ifTrue: [ self errorRequired ].
	(anObject isNil or: [ self includes: anObject ])
		ifFalse: [ self errorValidation ].! !

!MAElementDescription methodsFor: 'testing' stamp: 'lr 3/14/2005 11:09'!
validates: anObject
	[ self validate: anObject ] 
		on: Error 
		do: [ :err | ^false ].
	^true.! !

!MAElementDescription methodsFor: 'accessing-model' stamp: 'lr 3/14/2005 11:14'!
write: anObject to: aModel
	"Write to aModel using the receiver as description and anObject as value."

	self isReadonly
		ifTrue: [ self errorReadonly ]
		ifFalse: [ self validate: anObject ].
	^aModel write: anObject using: self.! !

!MAElementDescription methodsFor: 'private' stamp: 'lr 3/10/2005 15:53'!
writeSelector	
	^(self key copyWith: $:) 
		asSymbol.! !

MAElementDescription subclass: #MAMagnitudeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MAMagnitudeDescription subclass: #MADateDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MADateDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:43'!
defaultTitle
	^'Date Field'! !

!MADateDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADateDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:56'!
species
	^Date! !

MAMagnitudeDescription subclass: #MADurationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MADurationDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:26'!
defaultTitle
	^'Duration Field'! !

!MADurationDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MADurationDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:56'!
species
	^Duration.! !

!MAMagnitudeDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 16:17'!
comparators
	^super comparators , MAComparator magnitudeComparators.! !

!MAMagnitudeDescription methodsFor: 'converting' stamp: 'lr 3/17/2005 22:59'!
parseString: aString
	^self parseString: aString protected: [ self species fromString: aString ].! !

MAMagnitudeDescription subclass: #MANumberDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MANumberDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:43'!
defaultTitle
	^'Number Field'! !

!MANumberDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:29'!
isAbstract
	^false! !

!MANumberDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asNumber ].! !

!MANumberDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:56'!
species
	^Number! !

MAMagnitudeDescription subclass: #MATimeDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATimeDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Time Field'! !

!MATimeDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:57'!
species
	^Time! !

MAMagnitudeDescription subclass: #MATimeStampDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATimeStampDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:26'!
defaultTitle
	^'Timestamp Field'! !

!MATimeStampDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATimeStampDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:57'!
species
	^TimeStamp! !

MAElementDescription subclass: #MAOptionsDescription
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 18:38'!
defaultOptions
	^OrderedCollection new.! !

!MAOptionsDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Option-Box'! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/14/2005 12:16'!
descriptionDefault
	^nil! !

!MAOptionsDescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:09'!
descriptionOptions
	^MATextDescription key: #optionsTextual label: 'Options' priority: 140.! !

!MAOptionsDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAOptionsDescription methodsFor: 'testing' stamp: 'lr 3/11/2005 22:38'!
includes: anObject
	^self options includes: anObject.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/14/2005 19:22'!
options
	options isNil
		ifTrue: [ self options: self class defaultOptions ].
	^options.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/11/2005 22:37'!
options: aCollection
	options := aCollection! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual
	^self collectionToString: self options.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 18:38'!
optionsTextual: aString
	self options: (self stringToCollection: aString default: self class defaultOptions).! !

!MAOptionsDescription methodsFor: 'copying' stamp: 'lr 3/11/2005 22:36'!
postCopy
	super postCopy.
	self options: self options copy.! !

!MAOptionsDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:57'!
species
	^Object! !

MAElementDescription subclass: #MAStringDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

MAStringDescription subclass: #MAPasswordDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MAPasswordDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Password Field'! !

!MAPasswordDescription methodsFor: 'testing' stamp: 'lr 3/14/2005 14:09'!
isObfuscated: aString
	^aString notNil and: [ aString allSatisfy: [ :each | each = $* ] ].! !

!MAPasswordDescription methodsFor: 'converting' stamp: 'lr 3/11/2005 21:46'!
obfuscated: aString
	^aString isEmptyOrNil
		ifFalse: [ Array new: aString size withAll: $* ].! !

!MAStringDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 11:47'!
defaultDefault
	^String new.! !

!MAStringDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:24'!
defaultTitle
	^'Text Field'! !

!MAStringDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 16:17'!
comparators
	^super comparators , MAComparator stringComparators.! !

!MAStringDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:58'!
species
	^String! !

MAStringDescription subclass: #MASymbolDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MASymbolDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Symbol Field'! !

!MASymbolDescription methodsFor: 'converting' stamp: 'lr 3/14/2005 16:06'!
parseString: aString
	^self parseString: aString protected: [ aString asSymbol ].! !

!MASymbolDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:58'!
species
	^Symbol! !

MAStringDescription subclass: #MATextDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATextDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Memo Field'! !

MAElementDescription subclass: #MATableDescription
	instanceVariableNames: 'rowLabels columnLabels cellDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Descriptions'!

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/16/2005 20:33'!
defaultCellDescription
	^self defaultCellDescriptionClasses first new.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/17/2005 15:12'!
defaultCellDescriptionClasses
	^Array 
		with: MAStringDescription
		with: MATextDescription
		with: MANumberDescription
		with: MABooleanDescription.! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultColumnLabels
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultDefault
	^Array new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 22:37'!
defaultRowLables
	^OrderedCollection new! !

!MATableDescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/15/2005 21:25'!
defaultTitle
	^'Table'! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:10'!
descriptionCellDescription
	^(MAOptionsDescription key: #cellDescription label: 'Type' priority: 320 default: self defaultCellDescription)
		options: (self defaultCellDescriptionClasses collect: [ :each |
			each new
				label: each description label; 
				yourself ]);
		yourself.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:09'!
descriptionColumnLabels
	^MATextDescription key: #columnLabelsTextual label: 'Column Labels' priority: 300.! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:06'!
descriptionDefault
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/15/2005 09:20'!
descriptionRequired
	^nil! !

!MATableDescription class methodsFor: 'accessing-description' stamp: 'lr 3/17/2005 15:09'!
descriptionRowLabels
	^MATextDescription key: #rowLabelsTextual label: 'Row Labels' priority: 310.! !

!MATableDescription class methodsFor: 'testing' stamp: 'lr 3/19/2005 10:30'!
isAbstract
	^false! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:26'!
cellDescription
	cellDescription isNil
		ifTrue: [ self cellDescription: self class defaultCellDescription ].
	^cellDescription.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/16/2005 20:27'!
cellDescription: aDescription
	cellDescription := aDescription.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:38'!
columnCount
	^self columnLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels
	columnLabels isNil 
		ifTrue: [ self columnLabels: self class defaultColumnLabels ].
	^columnLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:35'!
columnLabels: aCollection
	columnLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual
	^self collectionToString: self columnLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 22:36'!
columnLabelsTextual: aString
	^self columnLabels: (self stringToCollection: aString default: self class defaultColumnLabels).! !

!MATableDescription methodsFor: 'copying' stamp: 'lr 3/16/2005 20:27'!
postCopy
	super postCopy.
	self rowLabels: self rowLabels copy.
	self columnLabels: self columnLabels copy.
	self cellDescription: self cellDescription copy.! !

!MATableDescription methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
rowCount
	^self rowLabels size.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 09:06'!
rowLabels
	rowLabels isNil 
		ifTrue: [ self rowLabels: self class defaultRowLables ].
	^rowLabels.! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/15/2005 08:50'!
rowLabels: aCollection
	rowLabels := aCollection! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:56'!
rowLabelsTextual
	^self collectionToString: self rowLabels.! !

!MATableDescription methodsFor: 'accessing-conveniance' stamp: 'lr 3/15/2005 08:57'!
rowLabelsTextual: aString
	^self rowLabels: (self stringToCollection: aString default: self class defaultRowLables).! !

!MATableDescription methodsFor: 'accessing' stamp: 'lr 3/17/2005 22:58'!
species
	^SequenceableCollection! !

Object subclass: #MAMockModel
	instanceVariableNames: 'values description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAMockModel methodsFor: 'private' stamp: 'lr 3/19/2005 10:32'!
buildDescription
	^self class description copy in: [ :container |
		MAElementDescription allSubclassesDo: [ :class |
			(class isAbstract and: [ class name beginsWith: 'MA' ]) ifTrue: [ 
				container add: (class 
					key: class name 
					label: class description label) ] ].
		container ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 14:57'!
description
	description isNil
		ifTrue: [ description := self buildDescription ].
	^description.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
readUsing: aDescription
	^self values 
		at: aDescription key 
		ifAbsent: [ nil ].! !

!MAMockModel methodsFor: 'accessing' stamp: 'lr 3/10/2005 16:54'!
values
	values isNil
		ifTrue: [ values := Dictionary new ].
	^values.! !

!MAMockModel methodsFor: 'accessing-model' stamp: 'lr 3/10/2005 14:50'!
write: anObject using: aDescription
	self values 
		at: aDescription key
		put: anObject.! !

Object subclass: #MAObjectStreaming
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

MAObjectStreaming subclass: #MAObjectReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAObjectStreaming class methodsFor: 'instance creation' stamp: 'lr 3/19/2005 12:33'!
on: aStream
	^self new
		setStream: aStream;
		yourself.! !

!MAObjectStreaming methodsFor: 'initialization' stamp: 'lr 3/19/2005 13:01'!
setStream: aStream
	stream := aStream! !

!MAObjectStreaming methodsFor: 'accessing' stamp: 'lr 3/19/2005 12:59'!
stream
	^stream! !

MAObjectStreaming subclass: #MAObjectWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Utilities'!

!MAObjectWriter methodsFor: 'as yet unclassified' stamp: 'lr 3/19/2005 13:29'!
nextPut: anObject
	" not working, need something more sofisticated than this "

	self stream 
		nextPutAll: 't1 := '; 
		nextPutAll: anObject class name; 
		nextPutAll: ' basicNew.'; 
		cr.
	anObject description do: [ :each |
		(each isPersistent and: [ each isReadonly not ]) ifTrue: [
			self stream 
				nextPutAll: 'd := t1 description at: '; 
				print: each key; 
				nextPutAll: '.'; 
				cr.
			self stream 
				nextPutAll: 'd write: (d parseString: '; 
				print: (each toString: (each read: anObject)); 
				nextPutAll: ') to: t1.';
				cr ] ].! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/11/2005 11:31'!
defaultContainer
	"Return the default description container."
	
	^MAPriorityContainer
		key: #yourself
		label: self defaultTitle.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 11:18'!
defaultTitle
	"Return the title of this class to be used in the description."
	
	^self name asString.! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:38'!
description
	^MACachedBuilder default buildFor: self.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:20'!
asLabel
	^self asString.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:39'!
readUsing: aDescription
	^self perform: aDescription readSelector.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 10:48'!
write: anObject using: aDescription
	self perform: aDescription writeSelector with: anObject.! !

!False methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'no'! !

!True methodsFor: '*Magritte-Core' stamp: 'lr 3/10/2005 22:21'!
asLabel
	^ 'yes'! !

TestCase subclass: #MAAbstractDescriptionTest
	instanceVariableNames: 'value other description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAAbstractDescriptionTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:46'!
isAbstract
	^super isAbstract
		or: [ self name includesSubString: 'Abstract' ].! !

!MAAbstractDescriptionTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:47'!
shouldInheritSelectors
	^true! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description
	^description! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description: anObject
	description := anObject! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:05'!
descriptionClass
	self subclassResponsibility! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:05'!
includedElement
	self subclassResponsibility! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/14/2005 11:12'!
invalidElement
	^Object new! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/14/2005 11:12'!
nullElement
	^nil! !

!MAAbstractDescriptionTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:05'!
nullString
	^String new! !

!MAAbstractDescriptionTest methodsFor: 'running' stamp: 'lr 3/14/2005 10:45'!
setUp
	self description: (self descriptionClass key: #value).! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value
	^value! !

!MAAbstractDescriptionTest methodsFor: 'accessing' stamp: 'lr 3/10/2005 11:27'!
value: anObject
	value := anObject! !

MAAbstractDescriptionTest subclass: #MAAbstractElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:42'!
testDefault
	description default: #foo.
	self assert: description default = #foo.
	
	! !

!MAAbstractElementTest methodsFor: 'testing-testing' stamp: 'lr 3/14/2005 11:12'!
testIncludes
	self assert: (self description includes: self includedElement).
	self deny: (self description includes: self invalidElement).
	self deny: (self description includes: self nullElement).! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 11:24'!
testKey
	description key: #foo.
	self assert: description key = #foo.
	
	! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 11:23'!
testLabel
	self description label: 'Foo'.
	self assert: self description label = 'Foo'.
	! !

!MAAbstractElementTest methodsFor: 'testing-converting' stamp: 'lr 3/17/2005 15:08'!
testMigrate
	| result |
	result := (MAStringDescription key: #value)
		migrate: self includedElement
		from: self description.
	self assert: (self description 
		toString: self includedElement) = result.! !

!MAAbstractElementTest methodsFor: 'testing-converting' stamp: 'lr 3/14/2005 16:09'!
testParseString
	self assert: (self description parseString: self nullElement) isNil.
	self assert: (self description parseString: self nullString) isNil.
	self assert: (self description includes: (description 
		parseString: (self description toString: self includedElement))).
	! !

!MAAbstractElementTest methodsFor: 'testing-settings' stamp: 'lr 3/19/2005 14:04'!
testPersistence
	self description bePersistent.
	self assert: self description persistent.
	self assert: self description isPersistent.
	
	self description beEphemeral.
	self deny: self description persistent.
	self deny: self description isPersistent.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 11:24'!
testPriority
	self description priority: 123.
	self assert: self description priority = 123.! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:23'!
testPropertiesAt
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyAt: #foo) = 'bar'.
	self should: [ description propertyAt: #bar ] raise: Error.
	! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:24'!
testPropertiesAtIfAbsent
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyAt: #foo ifAbsent: [ 'baz' ]) = 'bar'.
	self assert: (description propertyAt: #bar ifAbsent: [ 'baz' ]) = 'baz'.
	! !

!MAAbstractElementTest methodsFor: 'testing-properties' stamp: 'lr 3/14/2005 10:25'!
testPropertiesIncludes
	description propertyAt: #foo put: 'bar'.
	
	self assert: (description propertyIncludes: #foo).
	self deny: (description propertyIncludes: #bar).
	! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:49'!
testRead
	self value: (other := self includedElement).
	self assert: (self description read: self) = other.
	
	self value: (other := self nullElement).
	self assert: (self description read: self) = self description class defaultDefault.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:47'!
testReadSelector
	self assert: self description readSelector = #value.! !

!MAAbstractElementTest methodsFor: 'testing-settings' stamp: 'lr 3/14/2005 10:50'!
testReadonly
	self description beReadonly.
	self assert: self description readonly.
	self assert: self description isReadonly.
	self 
		should: [ self description write: self includedElement to: self ] 
		raise: Error.
	self assert: self value isNil.
	
	self description beWriteable.
	self deny: self description readonly.
	self deny: self description isReadonly.
	self 
		shouldnt: [ self description write: self includedElement to: self ] 
		raise: Error.
	self assert: self value notNil.! !

!MAAbstractElementTest methodsFor: 'testing-settings' stamp: 'lr 3/14/2005 10:53'!
testRequired
	self description beRequired.
	self assert: self description required.
	self assert: self description isRequired.
	self 
		should: [ self description write: nil to: self ] 
		raise: Error.
	self assert: self value isNil.
	self 
		shouldnt: [ self description write: self includedElement to: self ] 
		raise: Error.
	self deny: self value isNil.
	
	self description beOptional.
	self deny: self description required.
	self deny: self description isRequired.
	self 
		shouldnt: [ self description write: nil to: self ] 
		raise: Error.
	self assert: self value isNil.
	self 
		shouldnt: [ self description write: self includedElement to: self ] 
		raise: Error.
	self deny: self value isNil.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/17/2005 23:06'!
testSpecies
	self assert: (self includedElement isKindOf: self description species).! !

!MAAbstractElementTest methodsFor: 'testing-converting' stamp: 'lr 3/14/2005 10:49'!
testToString
	self assert: (self description toString: self includedElement) = self includedElement asString.! !

!MAAbstractElementTest methodsFor: 'testing-testing' stamp: 'lr 3/17/2005 23:07'!
testValidates
	self assert: (self description validates: self includedElement).
	self assert: (self description validates: self nullElement).
	self deny: (self description validates: self invalidElement).
	! !

!MAAbstractElementTest methodsFor: 'testing-settings' stamp: 'lr 3/14/2005 10:51'!
testVisible
	self description beVisible.
	self assert: self description visible.
	self assert: self description isVisible.
	
	self description beHidden.
	self deny: self description visible.
	self deny: self description isVisible.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 10:49'!
testWrite
	self description write: (other := self includedElement) to: self.
	self assert: self value = other.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:43'!
testWriteIncluded
	self
		should: [ self description write: self invalidElement to: self ]
		raise: MAValidationError.
	self assert: self value isNil.

	self
		shouldnt: [ self description write: self nullElement to: self ]
		raise: MAValidationError.
	self assert: self value isNil.
	
	self
		shouldnt: [ self description write: self includedElement to: self ]
		raise: MAValidationError.
	self deny: self value isNil.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:41'!
testWriteReadonly
	self description beReadonly.
	self
		should: [ self description write: self includedElement to: self ]
		raise: MAReadonlyError.
	self assert: self value isNil.
		
	self description beWriteable.
	self
		shouldnt: [ self description write: self includedElement to: self ]
		raise: MAReadonlyError.
	self assert: self value notNil.! !

!MAAbstractElementTest methodsFor: 'testing-model' stamp: 'lr 3/14/2005 11:40'!
testWriteRequired
	self description beRequired.
	self
		should: [ self description write: nil to: self ]
		raise: MARequiredError.
	self assert: self value isNil.
		
	self description beOptional.
	self
		shouldnt: [ self description write: nil to: self ]
		raise: MARequiredError.
	self assert: self value isNil.! !

!MAAbstractElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:47'!
testWriteSelector
	self assert: self description writeSelector = #value:.! !

MAAbstractElementTest subclass: #MABinaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MABinaryDescription! !

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^ByteArray with: 1 with: 2 with: 3.! !

MAAbstractElementTest subclass: #MABooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:11'!
descriptionClass
	^MABooleanDescription! !

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^true! !

MAAbstractElementTest subclass: #MADateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADateTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:11'!
descriptionClass
	^MADateDescription! !

!MADateTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:28'!
includedElement
	^Date newDay: 1 month: 2 year: 3456.! !

MAAbstractElementTest subclass: #MADurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADurationTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:03'!
descriptionClass
	^MADurationDescription! !

!MADurationTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:04'!
includedElement
	^Duration days: 1 hours: 2 minutes: 3 seconds: 4.! !

MAAbstractElementTest subclass: #MANumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MANumberTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:12'!
descriptionClass
	^MANumberDescription! !

!MANumberTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^123! !

MAAbstractElementTest subclass: #MAOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MAOptionsDescription! !

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^'Option 1'! !

!MAOptionsTest methodsFor: 'running' stamp: 'lr 3/16/2005 16:08'!
setUp
	super setUp.
	description options 
		add: 'Option 1'; 
		add: 'Option 2'; 
		add: 'Option 3'.! !

MAAbstractElementTest subclass: #MAStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

MAStringTest subclass: #MAPasswordTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAPasswordTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:08'!
descriptionClass
	^MAPasswordDescription! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:08'!
descriptionClass
	^MAStringDescription! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^'Hello World'! !

MAStringTest subclass: #MASymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:09'!
descriptionClass
	^MASymbolDescription! !

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^#foo! !

MAStringTest subclass: #MATextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATextTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:09'!
descriptionClass
	^MATextDescription! !

MAAbstractElementTest subclass: #MATimeStampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MATimeStampDescription! !

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:29'!
includedElement
	^TimeStamp year: 1 month: 2 day: 3456 hour: 7 minute: 8.! !

MAAbstractElementTest subclass: #MATimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MATimeTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MATimeDescription! !

!MATimeTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:28'!
includedElement
	^Time hour: 1 minute: 2 second: 3.! !

TestCase subclass: #MAComparatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MAComparatorTest methodsFor: 'utilities' stamp: 'lr 3/19/2005 21:49'!
assert: aFirstObject and: aSecondObject satisfies: aSelector
	self assert: ((MAComparator perform: aSelector) 
		compare: aFirstObject 
		with: aSecondObject).! !

!MAComparatorTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:39'!
comparators
	^MAComparator classPool values.! !

!MAComparatorTest methodsFor: 'utilities' stamp: 'lr 3/19/2005 21:49'!
deny: aFirstObject and: aSecondObject satisfies: aSelector
	self deny: ((MAComparator perform: aSelector) 
		compare: aFirstObject 
		with: aSecondObject).! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 21:48'!
testBeginsWith
	self assert: 'ab' and: 'a' satisfies: #beginsWith.
	self assert: 'ab' and: 'ab' satisfies: #beginsWith.
	
	self deny: 'ab' and: 'abc' satisfies: #beginsWith.
	self deny: 'ab' and: 'b' satisfies: #beginsWith.
	
	self deny: nil and: 'a' satisfies: #beginsWith.
	self deny: 'a' and: nil satisfies: #beginsWith. ! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 21:48'!
testEndsWith
	self assert: 'ab' and: 'b' satisfies: #endsWith.
	self assert: 'ab' and: 'ab' satisfies: #endsWith.
	
	self deny: 'ab' and: 'abc' satisfies: #endsWith.
	self deny: 'ab' and: 'a' satisfies: #endsWith.
	
	self deny: nil and: 'a' satisfies: #endsWith.
	self deny: 'a' and: nil satisfies: #endsWith. ! !

!MAComparatorTest methodsFor: 'testing-equality' stamp: 'lr 3/19/2005 21:47'!
testEqualTo
	self assert: 1 and: 1 satisfies: #equalTo.
	self deny: 1 and: 2 satisfies: #equalTo.! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testGreaterThan
	self deny: 1 and: 2 satisfies: #greaterThan.
	self deny: 1 and: 1 satisfies: #greaterThan.
	self assert: 2 and: 1 satisfies: #greaterThan.
	
	self deny: 1 and: nil satisfies: #greaterThan.
	self deny: nil and: 1 satisfies: #greaterThan.
! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testGreaterThanOrEqualTo
	self deny: 1 and: 2 satisfies: #greaterThanOrEqualTo.
	self assert: 1 and: 1 satisfies: #greaterThanOrEqualTo.
	self assert: 2 and: 1 satisfies: #greaterThanOrEqualTo.

	self deny: 1 and: nil satisfies: #greaterThanOrEqualTo.
	self deny: nil and: 1 satisfies: #greaterThanOrEqualTo.! !

!MAComparatorTest methodsFor: 'testing' stamp: 'lr 3/17/2005 23:41'!
testLabel
	self comparators do: [ :each | 
		self deny: each asLabel isEmptyOrNil.
		self deny: each asLabel = each asString ].! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testLessThan
	self assert: 1 and: 2 satisfies: #lessThan.
	self deny: 1 and: 1 satisfies: #lessThan.
	self deny: 2 and: 1 satisfies: #lessThan.
	
	self deny: 1 and: nil satisfies: #lessThan.
	self deny: nil and: 1 satisfies: #lessThan.! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testLessThanOrEqualTo
	self assert: 1 and: 2 satisfies: #lessThanOrEqualTo.
	self assert: 1 and: 1 satisfies: #lessThanOrEqualTo.
	self deny: 2 and: 1 satisfies: #lessThanOrEqualTo.
	
	self deny: 1 and: nil satisfies: #lessThanOrEqualTo.
	self deny: nil and: 1 satisfies: #lessThanOrEqualTo.! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 22:34'!
testMatch
	self assert: 'ab' and: '*' satisfies: #match.
	self assert: 'ab' and: '##' satisfies: #match.
	self assert: 'ab' and: '#b' satisfies: #match.
	self assert: 'ab' and: '*b' satisfies: #match.
	self assert: 'ab' and: 'a*b' satisfies: #match.
	self assert: 'ab' and: 'a#' satisfies: #match.
	self assert: 'ab' and: 'a*' satisfies: #match.
	self assert: 'ab' and: 'a' satisfies: #match.
	self assert: 'ab' and: 'b' satisfies: #match.
	
	self deny: 'ab' and: 'ba' satisfies: #match.
	self deny: 'ab' and: '?a' satisfies: #match.
	self deny: 'ab' and: 'b?' satisfies: #match.
	self deny: 'ab' and: '*a' satisfies: #match.
	self deny: 'ab' and: 'b*' satisfies: #match.

	self deny: nil and: 'a' satisfies: #match.
	self deny: 'a' and: nil satisfies: #match. ! !

!MAComparatorTest methodsFor: 'testing-equality' stamp: 'lr 3/19/2005 21:47'!
testNotEqualTo
	self deny: 1 and: 1 satisfies: #notEqualTo.
	self assert: 1 and: 2 satisfies: #notEqualTo.! !

!MAComparatorTest methodsFor: 'testing' stamp: 'lr 3/19/2005 21:51'!
testSelector
	self comparators do: [ :each | 
		self deny: each asSelector isEmptyOrNil ].! !

TestCase subclass: #MADynamicObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:35'!
testCalculated
	| object dummy |
	object := MADynamicObject on: [ Time millisecondsClockValue ].
	dummy := object yourself.
	
	(Delay forMilliseconds: 2) wait.
	self assert: dummy < object.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:35'!
testCollection
	| object |
	object := MADynamicObject on: [ OrderedCollection with: 1 with: 2 ].
	self assert: object size = 2.
	self assert: object first = 1.
	self assert: object second = 2.
	
	object add: 3.
	self assert: object size = 2.
	self assert: object first = 1.
	self assert: object second = 2.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:35'!
testConstant
	| object |
	object := MADynamicObject on: [ self ].
	self assert: object = self.
	
	object := MADynamicObject on: [ 123 ].
	self assert: object = 123.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:36'!
testNil
	| object |
	object := MADynamicObject on: 'abc'.
	self deny: object isNil.
	self assert: object notNil.
	
	object := MADynamicObject on: nil.
	self assert: object isNil.
	self deny: object notNil.! !
MAComparator initialize!
